'''
Spring 17 MCS-177 class In-class Practice 
Name 1: 
Name 2: 
Date: Insert the date
'''

##############
##############
### Part A

'''
WARM UP:
0. Recall from lecture that we can do the following
>>> for x in range(0,7,2):
	y = x + 4
	print(x,y)	
0 4
2 6
4 8
6 10

1. In the prompt, use the range command once to print the following:

24 23 22
21 20 19
18 17 16
15 14 13
12 11 10
9 8 7
6 5 4
3 2 1

2. In the prompt, use the range command to print the following:

42

3. In the prompt, use the range command to print the following:

0 0
1 1
2 4
3 9
4 16
5 25
6 36
7 49

4. In the prompt, use the accumulation pattern 
to compute the SUM of the first 5 odd positive numbers. 
(Reference: Session 2.5 page 55)
Check your answer by typing out 1+3+ ... to compute the sum
of the first 5 odd numbers.

PRACTICE A:
Below, write a function oddAverage which RETURNS
the average of the first N odd numbers.
Do not use any function such as the sum function.
Even though it is possible to use mathematical
arguments to answer this without accumulator pattern,
we want you to use the accumulator pattern
in this exercise.

Example:

>>> oddAverage(1)
1.0
>>> oddAverage(5)
5.0

Check that your code is correct for other
values of N, for example, N=6 or N=7

Question: What type of value does oddAverage return?

'''

def oddAverage(ReplaceThisWithSomethingDescriptive):
    print('OddAverage:Remove this line and replace with your lines of code')



##############
##############
### Part B

'''
WARM UP:
1. Recall from lecture that we can do the following:

>>> s='hello'
>>> for ch in s:
        print(ch*4 + ' 22')
hhhh 22
eeee 22
llll 22
llll 22
oooo 22

2. In the prompt, use a loop to print the following.

p
py
pyt
pyth
pytho
python
python 
python r
python ro
python roc
python rock
python rocks

(Hint: modify Session 2.5 page 55.)

3. In the prompt, write a loop which prints the following:

0  1  4  9  16  25  36  49 

(Hint: read about the str function in pages 91-92 and Session 3.7)

PRACTICE B: 
Below, write a function printLines which takes 1 parameter, 
a string, and produces a similar display as above. 
For example, calling the function

>>> printLines('python rocks') 

should produce the same display as above.

Question: What type of value does printLines return? 

'''

def printLines(ReplaceThisWithSomethingDescriptive):
    print('printLines:Remove this line and replace with your lines of code')


##############
##############
### Part C

'''
Recall that the Python built-in function len
returns the length of a string.
For example:

>>> len('python rocks')
12

We can also use len to compute the number of
integers in a sequence such as range(0,10,3)

>>> len(range(0,10,3))
4
>>> len(range(5,1))
0

PRACTICE C:
Below, write a function called rangeLen which RETURNS
the number of integers in range(start,stop,step).
Do not use the Python built-in funciton len.

Example:

>>> rangeLen(0,10,3)
4
>>> rangeLen(5,1,1)
0
>>> rangeLen(-10,10,3)
7

Question: What type of value does rangeLen return?

Question: If you want to find out,
how many multiples of 7 are there between 
-15 and 50, how can you use your function 
rangeLen to get an answer?
'''

def rangeLen(SomethingDescriptive1,SomethingDescriptive2,SomethingDescriptive3):
    print('rangeLen:Remove this line and replace with your lines of code')



############################
############################
# Start your tests
oddAverage(10)
printLines('python rocks') 
rangeLen(-10,10,3)
